<template>
    <div class="wrapper">
        <svg id="scatterplot"></svg>
    </div>
</template>

<script setup lang="ts">
import { useQueryStore } from '@/stores/query';
import { onMounted, ref, watch } from 'vue';
import * as d3 from "d3";

const query = useQueryStore();

onMounted(() => {
    if (query.query_row_data) drawScatterplot();
})

const drawScatterplot = () => {
    if (!query.query_studies) return;
    data.value = query.query_row_data;
    let phenotype_to_draw = 'PHENOTYPE_' + Object.keys(query.query_phenotypes!)[0];
    const margins = {top: 20, right: 30, left: 70, bottom: 60};
    const width = 1000 - margins.left - margins.right;
    const height = 600 - margins.top - margins.bottom;
    const svg = d3.select('#scatterplot')
        .attr("width", width + margins.left + margins.right)
        .attr("height", height + margins.top + margins.bottom)
        .append("g")
        .attr("transform", "translate(" + margins.left + "," + margins.top + ")");
    let test_met1 = query.query_active_metabolites[0];
    let test_met2 = query.query_active_metabolites[1];

    if (!data.value) return;
    const x = d3.scaleLinear().domain(
            d3.extent(data.value, function (d) {
                return d[test_met1];
            }) as [number, number]
    ).range([0, width-200]);
    svg.append("g").attr("transform", "translate(0," + height + ")").call(d3.axisBottom(x));

    const y = d3.scaleLinear().domain(
        d3.extent(data.value, function (d) {
            return d[test_met2];
        }) as [number, number]
    ).range([height, 0]);
    svg.append("g").call(d3.axisLeft(y)); 

    const colors = d3.scaleOrdinal()
        .domain(Object.keys(query.query_results))
        .range(d3.schemeTableau10);

    const shapes = d3.scaleOrdinal(d3.symbolsFill);
    const symbol = d3.symbol()

    svg.append("g").selectAll("dot").data(data.value).enter()
        .append("path")
        .attr("d", symbol.type(function (d) {
            return shapes(d[phenotype_to_draw])
        }))
        .attr("transform", function(d) { return "translate(" + x(d[test_met1]) + "," + y(d[test_met2]) +")"})
        .attr("cx", function (d) { return x(d[test_met1]); })
        .attr("cy", function (d) { return y(d[test_met2]); })
        .attr("r", 5)
        .style("fill", function (d):string { return colors(d['study']) as string; });


    svg.append("text")
    .attr("text-anchor", "end")
    .attr("x", width-200)
    .attr("y", height + margins.top + 20)
    .text(test_met1.substring(1));

    svg.append("text")
    .attr("text-anchor", "end")
    .attr("transform", "rotate(-90)")
    .attr("y", -margins.left + 20)
    .attr("x", -margins.top)
    .text(test_met2.substring(1))

    let base_x = width-180;
    let base_y = 0;

    for (let study of query.query_studies?.map((st) => st.study_id)) {

        svg.append("g").data(data.value).append("circle").attr("cx",base_x).attr("cy",base_y).attr("r", 10).style("fill", colors(study) as string).style("stroke", "black")
        svg.append("g").data(data.value).append("text").attr("x", base_x+20).attr("y", base_y+3).text(study).style("font-size", "15px").attr("alignment-baseline","middle")
        base_y += 30;
    }
    base_y += 50;
    for (let phenotype of query.query_phenotypes![Object.keys(query.query_phenotypes!)[0]].levels) {
        svg.append("g").data(data.value).append("path")
        .attr("d", symbol.type(function (d) {
            return shapes(phenotype)
        }))
        .attr("transform", function(d) { return "translate(" + base_x + "," + base_y +")"});
        svg.append("g").data(data.value).append("text").attr("x", base_x+20).attr("y", base_y+3).text(phenotype).style("font-size", "15px").attr("alignment-baseline","middle")
        base_y += 30;
    }
    


}

const data = ref([] as any[]);
watch(() => query.query_row_data, () => {
    drawScatterplot();
})
</script>

<style scoped>

.wrapper {
    margin: 5rem auto 0 auto;
    display: flex;
    align-items: center;
    justify-content: center;
    padding: 2rem;
    overflow: visible;
}

</style>